{% macro form (id, calendar=null, action="https://formasol.solstice.coop/form_submissions", title=true, description=true, submit="Je transmets ces informations") %}
  {% set formData = forms[id] %}
  {% set nameRe = r/\W(pré)?nom/i %}
  {% set locationRe = r/\W(lieu|adresse)/i %}
  {%- if forms[id] %}
    <article>
      {%- if title %}<h1>{{ formData.name }}</h1>{% endif -%}
      {%- if formData.description and description -%}
      {{ formData.description | trim | nl2br | safe }}
      {%- endif -%}
      <form method="post" class="card text-bg-light p-1 p-lg-3 my-3 js-external-form" action="{{ action }}" enctype="application/x-www-form-urlencoded" id="{{ id }}">
        <div class="card-body">
          <p class="d-none" aria-hidden="true">
            <label>
              Laisser vide : <input type="text" name="sweet" />
            </label>
          </p>
          <input type="hidden" name="form_id" value="{{ formData.id }}">
          <div class="alert alert-danger d-none" id="form-{{ formData.id }}-error">
              Oups, un problème s'est produit. On s'en occupe dès qu'on peut.
          </div>
          {%- for question in formData.questions -%}
            {% set id = ["form", id, "question", question.id] | join("-") %}
            {% if question.kind == 'email' %}
              {{- email(question, id) -}}
            {% elseif question.kind == 'url' %}
              {{- url(question, id) -}}
            {% elseif question.kind == 'tel' %}
              {{- phone(question, id) -}}
            {% elseif question.kind == 'number' %}
              {{- number(question, id) -}}
            {% elseif question.kind == 'textarea' %}
              {{- textarea(question, id) -}}
            {% elseif question.kind == 'check_box' %}
              {{- checkboxes(question) -}}
            {% elseif question.kind == 'radio_button' %}
              {{- radio(question) -}}
            {% elseif question.kind == 'text' %}
              {% if locationRe.test(question.name) %}
                {{- location(question, id) -}}
              {% elseif nameRe.test(question.name) %}
                {{- name(question, id) -}}
              {% else %}
                {{- text(question, id) -}}
              {% endif %}
            {% elseif calendar and (question.kind == 'select' or question.kind == 'date' or question.kind == 'datetime') %}
              {{- dateselect(question, id, calendar) -}}
            {% elseif question.kind == 'date' %}
              {{- date(question, id) -}}
            {% elseif question.kind == 'select' %}
              {{- select(question, id) -}}
            {% else %}
              {{- text(question, id) -}}
            {% endif %}
          {%- endfor -%}
          <button class="btn btn-primary" type="submit">
            <i class="fas fa-spinner fa-spin d-none" aria-hidden="true"></i>
            {{ submit }}
          </button>
        </div>
      </form>
    </article>
  {% else -%}
    <div class="alert alert-warning">
      Le formulaire {{ id }} n'est pas disponible actuellement.
    </div>
  {% endif -%}
{% endmacro %}

{% macro text(question, id) %}
  <div class="form-group" data-question-id={{ question.id }}>
    <label class="label {{ 'required' if question.required }}" for="{{ id }}">{{ question.name }}</label>
    <div class="input-group">
      <label class="input-group-text bg-body text-body-tertiary" for="{{ id }}" aria-hidden="true">
        <i class="fas fa-edit"></i>
      </label>
      <input id="{{ id }}" class="form-control border-start-0" type="text" {{ 'required' if question.required }} name="answers[{{ question.id }}][]">
    </div>
  </div>
{% endmacro %}

{% macro email(question, id) %}
  <div class="form-group" data-question-id={{ question.id }}>
    <label class="label {{ 'required' if question.required }}" for="{{ id }}">{{ question.name }}</label>
    <div class="input-group">
      <label class="input-group-text bg-body text-body-tertiary" for="{{ id }}" aria-hidden="true">
        <i class="fas fa-envelope"></i>
      </label>
      <input type="email" autocomplete="email" id="{{ id }}" class="form-control border-start-0" {{ 'required' if question.required }} name="answers[{{ question.id }}][]">
    </div>
  </div>
{% endmacro %}

{% macro url(question, id) %}
  <div class="form-group" data-question-id={{ question.id }}>
    <label class="label {{ 'required' if question.required }}" for="{{ id }}">{{ question.name }}</label>
    <div class="input-group">
      <label class="input-group-text bg-body text-body-tertiary" for="{{ id }}" aria-hidden="true">
        <i class="fas fa-globe"></i>
      </label>
      <input type="url" autocomplete="url" id="{{ id }}" class="form-control border-start-0" {{ 'required' if question.required }} name="answers[{{ question.id }}][]">
    </div>
  </div>
{% endmacro %}

{% macro number(question, id) %}
  <div class="form-group" data-question-id={{ question.id }}>
    <label class="label {{ 'required' if question.required }}" for="{{ id }}">{{ question.name }}</label>
    <div class="input-group">
      <label class="input-group-text bg-body text-body-tertiary" for="{{ id }}" aria-hidden="true">
        <i class="fas fa-th-large"></i>
      </label>
      <input type="text" pattern="\d*(.|,)?\d*" id="{{ id }}" class="form-control border-start-0" {{ 'required' if question.required }} name="answers[{{ question.id }}][]" title="Nombre uniquement (les virgule et points sont autorisés)">
    </div>
  </div>
{% endmacro %}

{% macro date(question, id) %}
  <div class="form-group" data-question-id={{ question.id }}>
    <label class="label {{ 'required' if question.required }}" for="{{ id }}">{{ question.name }}</label>
    <div class="input-group">
      <label class="input-group-text bg-body text-body-tertiary" for="{{ id }}" aria-hidden="true">
        <i class="fas fa-calendar"></i>
      </label>
      <input id="{{ id }}" class="form-control border-start-0" type="date" {{ 'required' if question.required }} name="answers[{{ question.id }}][]">
    </div>
  </div>
{% endmacro %}

{% macro phone(question, id) %}
  <div class="form-group" data-question-id={{ question.id }}>
    <label class="label {{ 'required' if question.required }}" for="{{ id }}">{{ question.name }}</label>
    <div class="input-group">
      <label class="input-group-text bg-body text-body-tertiary" for="{{ id }}" aria-hidden="true">
        <i class="fas fa-phone-square-alt"></i>
      </label>
      <input type="tel" autocomplete="tel" id="{{ id }}" class="form-control border-start-0" {{ 'required' if question.required }} name="answers[{{ question.id }}][]">
    </div>
  </div>
{% endmacro %}

{% macro name(question, id) %}
  <div class="form-group" data-question-id={{ question.id }}>
    <label class="label {{ 'required' if question.required }}" for="{{ id }}">{{ question.name }}</label>
    <div class="input-group">
      <label class="input-group-text bg-body text-body-tertiary" for="{{ id }}" aria-hidden="true">
        <i class="fas fa-user"></i>
      </label>
      <input type="text" autocomplete="name" id="{{ id }}" class="form-control border-start-0" {{ 'required' if question.required }} name="answers[{{ question.id }}][]">
    </div>
  </div>
{% endmacro %}

{% macro location(question, id) %}
  <div class="form-group" data-question-id={{ question.id }}>
    <label class="label {{ 'required' if question.required }}" for="{{ id }}">{{ question.name }}</label>
    <div class="input-group">
      <label class="input-group-text bg-body text-body-tertiary" for="{{ id }}" aria-hidden="true">
        <i class="fas fa-map-marker"></i>
      </label>
      <input type="text" autocomplete="address-level2" id="{{ id }}" class="form-control border-start-0" {{ 'required' if question.required }} name="answers[{{ question.id }}][]">
    </div>
  </div>
{% endmacro %}

{% macro textarea(question, id) %}
  <div class="form-group" data-question-id={{ question.id }}>
    <label class="label {{ 'required' if question.required }}" for="{{ id }}">{{ question.name }}</label>
    <textarea id="{{ id }}" class="form-control" {{ 'required' if question.required }} name="answers[{{ question.id }}][]"></textarea>
  </div>
{% endmacro %}

{% macro checkboxes(question) %}
  <fieldset class="form-group" data-question-id={{ question.id }}>
    <legend class="label {{ 'required' if question.required }}">{{ question.name }}</legend>
    {%- for option in question.options -%}
      <div class="form-check">
        <input type="checkbox" name="answers[{{ question.id }}][]" value="{{ option.id }}" {{ 'required' if (question.required and question.options.length === 1)}} class="form-check-input" id="check_{{ question.id }}_{{ option.id }}">
        <label class="form-check-label" for="check_{{ question.id }}_{{ option.id }}">
          {{ option.name }}
        </label>
      </div>
    {%- endfor -%}
  </fieldset>
{% endmacro %}

{% macro radio(question) %}
  <fieldset class="form-group" data-question-id={{ question.id }}>
    <legend class="label {{ 'required' if question.required }}">{{ question.name }}</legend>
    {%- for option in question.options -%}
      <div class="form-check">
        <input type="radio" class="form-check-input" name="answers[{{ question.id }}][]" value="{{ option.id }}" id="radio_{{ question.id }}_{{ option.id }}">
        <label class="form-check-label" for="radio_{{ question.id }}_{{ option.id }}">
          {{ option.name }}
        </label>
      </div>
    {%- endfor -%}
  </fieldset>
{% endmacro %}

{% macro select(question, id) %}
  <div class="form-group" data-question-id={{ question.id }}>
    <label class="label {{ 'required' if question.required }}" for="{{ id }}">{{ question.name }}</label>
    <div class="input-group">
      <label class="input-group-text bg-body text-body-tertiary" for="{{ id }}" aria-hidden="true">
        <i class="fas fa-calendar-check"></i>
      </label>
      <select class="form-select border-start-0" name="answers[{{ question.id }}][]" id="{{ id }}" {{ 'required' if question.required }}>
        <option value="">Choisir une option</option>
        {%- for option in question.options -%}
        <option value="{{ option.id }}">
          {{ option.name }}
        </option>
        {%- endfor -%}
      </select>
    </div>
  </div>
{% endmacro %}

{% macro dateselect(question, id, options) %}
  <div class="form-group" data-question-id={{ question.id }}>
    <label class="label {{ 'required' if question.required }}" for="{{ id }}">{{ question.name }}</label>
    <div class="input-group">
      <label class="input-group-text bg-body text-body-tertiary" for="{{ id }}" aria-hidden="true">
        <i class="fas fa-calendar-check"></i>
      </label>
      <select class="form-select border-start-0" name="answers[{{ question.id }}][]" id="{{ id }}" {{ 'required' if question.required }}>
        <option value="">Choisir une date</option>
        {%- for event in options -%}
        <option value="{{ event.startDate | toDateTime }}" data-event="{{ event.uid }}">
          {{ event.startDate | toDateTime }}
          {% if (event.location | locationMode).mode != 'EMPTY' %} ({{ event.location | locationShort('en visio', 'en présentiel') }}){% endif %}
        </option>
        {%- endfor -%}
      </select>
    </div>
  </div>
{% endmacro %}
